#include <string.h>

#include "fdimg.h"
#include "d88.h"


#define	GAP4LENGTH	50		// GAP4(MFM) l͂悭킩Ȃ

// -------------------------------------------------------------
// ZN^NX
// -------------------------------------------------------------
////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
FDSEC::FDSEC( BYTE cc, BYTE hh, BYTE rr, BYTE nn, BYTE den, BYTE del, BYTE sta )
{
	c       = cc;
	h       = hh;
	r       = rr;
	n       = nn;
	density = den;
	deleted = del;
	status  = sta;
	data    = NULL;
	next    = NULL;
	secoff  = 0;
	reltime = 0;
	
	Resize( nn );
}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
FDSEC::~FDSEC( void )
{
	if( data ) delete [] data;
	if( next ) delete next;
}


////////////////////////////////////////////////////////////////
// ep[^擾Eݒ
////////////////////////////////////////////////////////////////
BYTE FDSEC::C( void ){ return c; }						// C擾
BYTE FDSEC::H( void ){ return h; }						// H擾
BYTE FDSEC::R( void ){ return r; }						// R擾
BYTE FDSEC::N( void ){ return n; }						// N擾
BYTE FDSEC::Density( void ){ return density; }			// L^x擾
void FDSEC::SetDensity( BYTE de ){ density = de; }		// L^xݒ
BYTE FDSEC::Deleted( void ){ return deleted; }			// DELETED MARK擾
void FDSEC::SetDeleted( BYTE de ){ deleted = de; }		// DELETED MARKݒ
BYTE FDSEC::Status( void ){ return status; }			// Xe[^X擾
void FDSEC::SetStatus( BYTE st ){ status = st; }		// Xe[^Xݒ
WORD FDSEC::DataSize( void ){ return dsize; }			// f[^TCY擾
BYTE *FDSEC::Buffer( void ){ return data; }				// f[^ւ̃|C^擾
FDSEC *FDSEC::Next( void ){ return next; }				// ̃ZN^ւ̃|C^擾
void FDSEC::SetNext( FDSEC *sec ){ next = sec; }		// ̃ZN^ւ̃|C^ݒ
int FDSEC::SectorOffset( void ){ return secoff; }		// ZN^ItZbg擾
void FDSEC::SetSectorOffset( int so ){ secoff = so; }	// ZN^ItZbgݒ
DWORD FDSEC::RelTime( void ){ return reltime; }			// CfbNXz[̎(us)擾
void FDSEC::SetRelTime( DWORD lt ){ reltime = lt; }		// CfbNXz[̎(us)ݒ


////////////////////////////////////////////////////////////////
// f[^擾
////////////////////////////////////////////////////////////////
bool FDSEC::GetData( BYTE *buf, WORD sz )
{
	if( !buf || !data ) return false;
	return memcpy( buf, data, dsize > sz ? sz : dsize ) ? true : false;
}


////////////////////////////////////////////////////////////////
// f[^ݒ
////////////////////////////////////////////////////////////////
bool FDSEC::SetData( BYTE *buf, WORD sz )
{
	if( !buf || !data ) return false;
	return memcpy( data, buf, sz > dsize ? dsize : sz ) ? true : false;
}


////////////////////////////////////////////////////////////////
// f[^TCYύX
//  f[^Ȃ̏ꍇ0xff
////////////////////////////////////////////////////////////////
bool FDSEC::Resize( BYTE nn )
{
	if( data ) delete [] data;
	
	if( nn == 0xff ){
		dsize = 0;
		data  = NULL;
		return true;
	}
	
	dsize = 128 << (( nn > 8 ) ? 8 : nn);
	if( !(data = new BYTE[dsize]) ){
		dsize = 0;
		return false;
	}
	ZeroMemory( data, dsize );
	return true;
}





// -------------------------------------------------------------
// gbNNX
// -------------------------------------------------------------
////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
FDTRK::FDTRK( void )
{
	fdtype  = FDUNKNOWN;
	sectors = NULL;
}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
FDTRK::~FDTRK( void )
{
	Unformat();
}


////////////////////////////////////////////////////////////////
// ep[^擾Eݒ
////////////////////////////////////////////////////////////////
void FDTRK::SetType( BYTE tp ){ fdtype = tp; }	// fBXN̎ސݒ
BYTE FDTRK::Count( void )						// ZN^擾
{
	BYTE cn = 0;
	FDSEC *psc = sectors;
	while( psc ){
		psc = psc->Next();
		cn++;
	}
	return cn;
}




////////////////////////////////////////////////////////////////
// ZN^߂(~bNXZN^tH[}bg)
////////////////////////////////////////////////////////////////
int FDTRK::SpritSector( int nsec, BYTE secmin )
{
	if( (nsec < 1) || (nsec > Count()) ) return 0;
	
	int misc  = Sector( nsec )->Density() == 0x40 ? 6+1+4+2+11+6+1+2 : 12+4+4+2+22+12+4+2;
	int ssize = (128<<secmin) + misc + Gap3();
	int asize = -((128<<ActualSectorSize( nsec )) + misc + 2 );
	int snum  = 0;
	while( asize < 0 ){
		asize += ssize;
		snum++;
	}
	return snum;
}



////////////////////////////////////////////////////////////////
// GAP3擾
////////////////////////////////////////////////////////////////
BYTE FDTRK::Gap3( void )
{
	if( !Count() ) return 0;
	
	// tH[}bg̃ZN^TCY߂
	BYTE secmin = ActualSectorSize( 1 );
	for( int i=1; i <= Count(); i++ ){
		secmin = min( secmin, ActualSectorSize( i ) );
	}
	
	BYTE mgap = 0;
	int max   = 0;
	bool fm   = Sector( 1 )->Density() == 0x40;
	int tcap  = (TRACKCAP( fdtype ) -80-12-4-50 - GAP4LENGTH) / (fm ? 2 : 1);
	int misc  = fm ? 6+1+4+2+11+6+1+2 : 12+4+4+2+22+12+4+2;
	
	// GAP3̍őlPC-98 BIOS̕Wlɍ킹ĐĂ
//	const BYTE gap3[][9] = {
//		{ 0x33, 0x33, 0x50, 0x74, 0x74, 0x74, 0x74, 0x74, 0x74 },	// MFM
//		{ 0x1b, 0x2a, 0x3a, 0x3a, 0x3a, 0x3a, 0x3a, 0x3a, 0x3a } };	// FM
	for( int gap3=2; gap3 < (fm ? 0x3a : 0x74); gap3++ ){
		int sgap  = 19999;
		int ssize = (128<<secmin) + misc + gap3;
		int tsize = 0;
		for( int i=1; i <= Count(); i++ ){
			int asize  = -((128<<ActualSectorSize( i )) + misc + 2);
			
			while( asize < 0 ){
				asize += ssize;
				tsize += ssize;
			}
			if( sgap >= asize ) sgap = asize;
		}
		
		if( tsize < tcap && max < sgap ){
			max  = sgap;
			mgap = gap3;
		}
	}
	return mgap;
}


////////////////////////////////////////////////////////////////
// ZN^ItZbgݒ
////////////////////////////////////////////////////////////////
void FDTRK::SetSectorOffset( void )
{
	if( !sectors ) return;
	
	FDSEC *sec0 = sectors;
	while( sec0 ){
		int so = 0;
		FDSEC *sec1 = sectors;
		while( sec0 != sec1 ){
			if( (sec0->C() == sec1->C()) && (sec0->H() == sec1->H()) &&
				(sec0->R() == sec1->R()) && (sec0->N() == sec1->N()) ){
				if( !so ) so = 1;
				sec1->SetSectorOffset( so++ );
			}
			sec1 = sec1->Next();
		}
		sec0->SetSectorOffset( so );
		sec0 = sec0->Next();
	}
}


////////////////////////////////////////////////////////////////
// ZN^擾
////////////////////////////////////////////////////////////////
FDSEC *FDTRK::Sector( BYTE sc )
{
	FDSEC *psc = sectors;
	while( --sc ){
		if( psc->Next() )
			psc = psc->Next();
		else
			return NULL;
	}
	return psc;
}

////////////////////////////////////////////////////////////////
// ZN^ǉ
////////////////////////////////////////////////////////////////
FDSEC *FDTRK::AddSector( BYTE cc, BYTE hh, BYTE rr, BYTE nn, BYTE den, BYTE del, BYTE sta )
{
	FDSEC *ns = new FDSEC( cc, hh, rr, nn, den, del, sta );
	if( !ns ) return NULL;
	
	if( !sectors )
		sectors = ns;
	else{
		FDSEC *ls = sectors;
		while( ls->Next() )
			ls = ls->Next();
		ls->SetNext( ns );
	}
	
	SetSectorOffset();
	
	return ns;
}


////////////////////////////////////////////////////////////////
// tH[}bg
////////////////////////////////////////////////////////////////
bool FDTRK::Format( BYTE sc, BYTE cc, BYTE hh, BYTE nn, BYTE den )
{
	Unformat();
	
	for( int i=1; i < sc+1; i++ ){
		if( !AddSector( cc, hh, i, nn, den ) )
			return false;
	}
	return true;
}


////////////////////////////////////////////////////////////////
// AtH[}bg
////////////////////////////////////////////////////////////////
void FDTRK::Unformat( void )
{
	if( sectors ){
		delete sectors;
		sectors = NULL;
	}
}


////////////////////////////////////////////////////////////////
// ۂɗLƎvZN^TCY擾(DATA CRC ERRORZN^̏ꍇ)
////////////////////////////////////////////////////////////////
BYTE FDTRK::ActualSectorSize( int nsec )
{
	if( (nsec < 1) || (nsec > Count()) ) return 0xff;
	
	FDSEC *sec = Sector( nsec );
	FDSEC *nec = sec->Next();
	
	// "DATA CRC ERROR"  "ŏIZN^łȂ" ȊON̂܂ܕԂ
	if( !((sec->Status() == BIOS_DATA_CRC_ERROR) && nec) )
		return sec->N();
	
	// p^[쐬(̃ZN^ID)
	BYTE strs[] = { 0xff, 0,0,0,0,0,0,             0xfe,                   0,0,0,0 };
	BYTE strd[] = { 0x4e, 0,0,0,0,0,0,0,0,0,0,0,0, 0xa1, 0xa1, 0xa1, 0xfe, 0,0,0,0 };
	bool fm = sec->Density() == 0x40;
	BYTE *pst = fm ? &strs[8] : &strd[17];
	*(pst++) = nec->C();
	*(pst++) = nec->H();
	*(pst++) = nec->R();
	*(pst++) = nec->N();
	pst = fm ? strs : strd;
	
	BYTE *sdata = sec->Buffer();
	BYTE sz     = 0;
	DWORD dlen  = 0;
	
	// reltimeΎԂŔ(DISKǂݎf[^̏ꍇ)
	if( sec->RelTime() && nec->RelTime() ){
		DWORD stime = nec->RelTime() - sec->RelTime();
		DWORD rate  = fdtype&FD_HIGHDENSITY ? 500 : 250;
		DWORD misc  = fm ? 6+1+4+2+11+6+1+2 : 12+4+4+2+22+12+4+2;
		
		dlen  = stime * (fm ? rate/2 : rate) / 8000 - misc - 1;	// DATA+GAP3
		
		// GAP3DATA CRC
		while( sdata[dlen] == pst[0] ) dlen--; dlen--;
		// TCYNɕϊ
		while( dlen/(128<<sz) > 1 ) sz++;
		
	// reltime΃f[^r(C[Wt@C̏ꍇ)
	}else{
		DWORD ssize = fm ? sizeof(strs) : sizeof(strd);
		DWORD dsize = (128<<((sec->N()>8) ? 8 : sec->N())) - ssize;
		
		do{
			if( memcmp( &sdata[dlen], pst, ssize ) == 0 ) break;
			dlen++;
		}while( dlen < dsize );
		
		if( dlen < dsize ){
			// GAP3DATA CRC
			while( sdata[dlen] == pst[0] ) dlen--; dlen--;
			// TCYNɕϊ
			while( dlen/(128<<sz) > 1 ) sz++;
		}else{
			// p^[ȂΑSf[^LƔf
			sz = sec->N();
		}
	}
	return sz;
}


///////////////////////////////////////////////////////////////////////////////
// Pf[^ZN^?
///////////////////////////////////////////////////////////////////////////////
bool FDTRK::CheckUniqueData( int nsec )
{
	if( (nsec < 1) || (nsec > Count()) ) return false;
	
	int ssize  = 128<<ActualSectorSize( nsec );
	BYTE *dat  = Sector( nsec )->Buffer();
	
	for( int i=1; i < ssize; i++ ){
		if( dat[i] != dat[0] )
			return false;
	}
	return true;
}



// -------------------------------------------------------------
// tbs[fBXNC[WNX
// -------------------------------------------------------------
////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
FDimg::FDimg( void )
{
	fdtype  = FDUNKNOWN;
	protect = false;
	ZeroMemory( title, sizeof(title) );
	Unformat();
}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
FDimg::~FDimg( void )
{
}


////////////////////////////////////////////////////////////////
// ep[^擾Eݒ
////////////////////////////////////////////////////////////////
char *FDimg::Title( void ){ return title; }			// fBXN̖O擾
void FDimg::SetTitle( const char *t )				// fBXN̖Oݒ
{
	ZeroMemory( title, sizeof(title) );
	if( t ) memcpy( title, t, min( sizeof(title)-1, strlen(t) ) );
}
BYTE FDimg::Type( void ){ return fdtype; }			// fBXN̎ގ擾
void FDimg::SetType( BYTE tp )						// fBXN̎ސݒ
{
	fdtype = tp;
	for( int i=0; i<MAX_CYLINDER*2; i++ )
		track[i].SetType( fdtype );
}
bool FDimg::Protect( void ){ return protect; }		// CgveNg擾
void FDimg::SetProtect( bool wp ){ protect = wp; }	// CgveNgݒ


////////////////////////////////////////////////////////////////
// ЖʃfBXN?
////////////////////////////////////////////////////////////////
bool FDimg::IsSingleSide( void )
{
	for( int i=1; i < MAX_CYLINDER*2; i += 2 )
		if( track[i].Count() ) return false;
	return true;
}


////////////////////////////////////////////////////////////////
// gbN擾
////////////////////////////////////////////////////////////////
FDTRK *FDimg::Track( BYTE cyl, BYTE head )
{
	if( cyl >= MAX_CYLINDER || head > 1 ) return NULL;
	else return &track[cyl*2+head];
}


////////////////////////////////////////////////////////////////
// AtH[}bg
////////////////////////////////////////////////////////////////
void FDimg::Unformat( void )
{
	for( int i=0; i < MAX_CYLINDER*2; i++ )
		track[i].Unformat();
}


// -------------------------------------------------------------
// D88fBXNC[WNX
// -------------------------------------------------------------
////////////////////////////////////////////////////////////////
// RXgN^
////////////////////////////////////////////////////////////////
D88DISK::D88DISK( void )
{
}


////////////////////////////////////////////////////////////////
// fXgN^
////////////////////////////////////////////////////////////////
D88DISK::~D88DISK( void )
{
}


////////////////////////////////////////////////////////////////
// gbNf[^Ǎ
////////////////////////////////////////////////////////////////
bool D88DISK::ReadFileTrack( FILE *fp, BYTE trk, FDTRK *track )
{
	D88SECTINFO sinfo;
	DWORD offset;
	int i=0;
	
	if( !fp || !track || (trk >= MAX_CYLINDER*2) ) return false;
	
	track->Unformat();
	
	// gbNf[^e[uǍ
	fseek( fp, 32 + trk * sizeof(DWORD), SEEK_SET );
	fread( &offset, sizeof(DWORD), 1, fp );
	if( offset ){
		fseek( fp, offset, SEEK_SET );
		do{
			// ZN^Ǎ
			fread( &sinfo, sizeof(D88SECTINFO), 1, fp );
			FDSEC *sec = track->AddSector( sinfo.c, sinfo.h, sinfo.r, sinfo.n, sinfo.density, sinfo.deleted, sinfo.status );
			
			// ZN^f[^Ǎ
			fread( sec->Buffer(), sizeof(BYTE), sec->DataSize(), fp );
		}while( ++i < sinfo.sec_nr );
	}
	return true;
}


////////////////////////////////////////////////////////////////
// gbNf[^
////////////////////////////////////////////////////////////////
bool D88DISK::WriteFileTrack( FILE *fp, BYTE trk, FDTRK *track )
{
	D88SECTINFO sinfo;
	DWORD offset=0;
	
	if( !fp || !track || (trk >= MAX_CYLINDER*2) ) return false;
	
	if( track->Count() ){
		fseek( fp, 0, SEEK_END );
		offset = ftell( fp );
		
		for( int i=1; i < track->Count()+1; i++ ){
			FDSEC *sec = track->Sector( i );
			// ZN^񏑍
			ZeroMemory( &sinfo, sizeof(D88SECTINFO) );
			sinfo.c       = sec->C();			// ID  C (V_No Жʂ̏ꍇ=gbNNo)
			sinfo.h       = sec->H();			// ID  H (wb_AhX Жʂ̏ꍇ=0)
			sinfo.r       = sec->R();			// ID  R (gbÑZN^No)
			sinfo.n       = sec->N();			// ID  N (ZN^TCY 0:128 1:256 2:512 3:1024)
			sinfo.sec_nr  = track->Count();		// ̃gbNɑ݂ZN^̐
			sinfo.density = sec->Density();		// L^x     0x00:{x   0x40:Px
			sinfo.deleted = sec->Deleted();		// DELETED MARK 0x00:m[} 0x10:DELETED
			sinfo.status  = sec->Status();		// Xe[^X
			sinfo.size	  = sec->DataSize();	// ̃ZN^̃f[^TCY
			if( fwrite( &sinfo, sizeof(D88SECTINFO), 1, fp ) < 1 )
				return false;
			
			// ZN^f[^
			if( fwrite( sec->Buffer(), sizeof(BYTE), sinfo.size, fp ) < sinfo.size )
				return false;
		}
	}
	
	// gbNf[^e[u
	fseek( fp, 32 + trk * sizeof(DWORD), SEEK_SET );
	if( fwrite( &offset, sizeof(DWORD), 1, fp ) < 1 )
		return false;
	
	return true;
}


////////////////////////////////////////////////////////////////
// C[Wt@CǍ
//  1D=>2D,1DD=>2DDƂēǍ܂̂Œ(\ȂΕ␳Ă݂)
////////////////////////////////////////////////////////////////
bool D88DISK::ReadFromFile( const char *fname )
{
	D88HEADER d88h;
	int step;
	
	FILE *fp = fopen( fname, "rb" );
	if( !fp ) return false;
	
	// wb_Ǎ
	fread( &d88h, sizeof(D88HEADER), 1, fp );
	memcpy( title, d88h.name, 16 );
	title[16] = 0;
	switch( d88h.type ){
	case 0x00:	fdtype = FD2D;		break;
	case 0x10:	fdtype = FD2DD;		break;
	case 0x20:	fdtype = FD2HD;		break;
	case 0x40:	fdtype = FD1DD;		break;	// 1DDitt
	default:	fdtype = FDUNKNOWN;
	}
	protect = d88h.protect;			// CgveNg
	
	// gbNǍ
	if( fdtype == FD1DD ){	// 1DDittC[W͕ʏ
		for( BYTE cyl = 0; cyl < MAX_CYLINDER; cyl++ )
			ReadFileTrack( fp, cyl, &track[cyl*2] );
	}else{
		step = fdtype&FD_DOUBLETRACK ? 1 : 2;
		for( BYTE cyl = 0; cyl < MAX_CYLINDER; cyl += step )
			for( BYTE head = 0; head < 2; head++ )
				ReadFileTrack( fp, cyl*2/step+head, &track[cyl*2+head] );
	}
	
	fclose( fp );
	
	// ЖʃfBXN̏ꍇ
	if( !(fdtype&FD_HIGHDENSITY) && IsSingleSide() )
		fdtype &= ~FD_DOUBLESIDE;
	
	return true;
}


////////////////////////////////////////////////////////////////
// C[Wt@Cɏ
////////////////////////////////////////////////////////////////
bool D88DISK::WriteToFile( const char *fname, BYTE flag )
{
	D88HEADER d88h;
	int step;
	
	protect = (flag&FD_PROTECT) ? true : false;
	
	FILE *fp = fopen( fname, "wb" );
	if( !fp ) return false;
	
	// wb_񏑍
	ZeroMemory( &d88h, sizeof(D88HEADER) );
	memcpy( d88h.name, title, 16 );
	d88h.protect = protect ? 0x10 : 0;
	switch( fdtype ){
	case FD1D:	d88h.type = 0x00;	break;
	case FD2D:	d88h.type = 0x00;	break;
	case FD1DD:	d88h.type = (flag&FD_1DDITT) ? 0x40 : 0x10;	break;
	case FD2DD:	d88h.type = 0x10;	break;
	case FD2HD:	d88h.type = 0x20;	break;
	default:	d88h.type = 0x00;
	}
	fwrite( &d88h, sizeof(D88HEADER), 1, fp );
	
	// gbN
	if( d88h.type == 0x40 ){	// 1DDittC[W͕ʏ
		for( BYTE cyl = 0; cyl < MAX_CYLINDER; cyl++ )
			WriteFileTrack( fp, cyl, &track[cyl*2] );
	}else{
		step = fdtype&FD_DOUBLETRACK ? 1 : 2;
		for( BYTE cyl = 0; cyl < MAX_CYLINDER; cyl += step )
			for( BYTE head = 0; head < 2; head++ )
				WriteFileTrack( fp, cyl*2/step+head, &track[cyl*2+head] );
	}
	
	// t@CTCY
	fseek( fp, 0, SEEK_END );
	d88h.size = ftell( fp );
	fseek( fp, 0, SEEK_SET );
	fwrite( &d88h, sizeof(BYTE), 32, fp );
	
	fclose( fp );
	
	return true;
}
