#ifndef FDIMG_H_INCLUDED
#define FDIMG_H_INCLUDED

#include <stdio.h>
#include "tdef.h"


#define FD_DOUBLESIDE			0x01	// 
#define	FD_DOUBLETRACK			0x02	// {gbN
#define	FD_DOUBLEDENSITY		0x04	// {x
#define	FD_HIGHDENSITY			0x08	// x

#define	FD1D					(FD_DOUBLEDENSITY)
#define	FD2D					(FD_DOUBLESIDE|FD_DOUBLEDENSITY)
#define	FD1DD					(FD_DOUBLETRACK|FD_DOUBLEDENSITY)
#define	FD2DD					(FD_DOUBLESIDE|FD_DOUBLETRACK|FD_DOUBLEDENSITY)
#define	FD2HD					(FD_DOUBLESIDE|FD_DOUBLETRACK|FD_HIGHDENSITY)
#define	FDUNKNOWN				0xff

#define	TRACKCAP(t)				((t)&FD_HIGHDENSITY ? 12500 : (t)&FD_DOUBLEDENSITY ? 6250 : 3125)

#define	FD_PROTECT				0x01
#define	FD_1DDITT				0x20

// Disk BIOS Status
#define BIOS_READY				(0x00)
#define BIOS_WRITE_PROTECT		(0x70)
#define BIOS_ID_CRC_ERROR		(0xa0)
#define BIOS_DATA_CRC_ERROR		(0xb0)
#define BIOS_NO_DATA			(0xc0)
#define BIOS_MISSING_IAM		(0xe0)
#define BIOS_MISSING_DAM		(0xf0)



#define	MAX_CYLINDER			82


////////////////////////////////////////////////////////////////
// NX`
////////////////////////////////////////////////////////////////
// ZN^NX
class FDSEC {
private:
	BYTE c;							// ID  C (V_No Жʂ̏ꍇ=gbNNo)
	BYTE h;							// ID  H (wb_AhX Жʂ̏ꍇ=0)
	BYTE r;							// ID  R (gbÑZN^No)
	BYTE n;							// ID  N (ZN^TCY 0:128 1:256 2:512 3:1024)
	BYTE density;					// L^x     0x00:{x   0x40:Px
	BYTE deleted;					// DELETED MARK 0x00:m[} 0x10:DELETED
	BYTE status;					// Xe[^X
	WORD dsize;						// ̃ZN^̃f[^TCY
	
	BYTE *data;						// f[^ւ̃|C^
	FDSEC *next;					// ̃ZN^ւ̃|C^
	
	int secoff;						// ZN^ItZbg(gbNɓID̃ZN^ꍇ̒ʂԍ)
									// 1Ȃ0, 2ȏ゠ꍇ1,2,3...
	DWORD reltime;					// CfbNXz[̎(us)
	
public:
	FDSEC( BYTE, BYTE, BYTE, BYTE, BYTE=0, BYTE=0, BYTE=0 );	// RXgN^
	~FDSEC();						// fXgN^
	
	BYTE C();						// C擾
	BYTE H();						// H擾
	BYTE R();						// R擾
	BYTE N();						// N擾
	BYTE Density();					// L^x擾
	void SetDensity( BYTE );		// L^xݒ
	BYTE Deleted();					// DELETED MARK擾
	void SetDeleted( BYTE );		// DELETED MARKݒ
	BYTE Status();					// Xe[^X擾
	void SetStatus( BYTE );			// Xe[^Xݒ
	WORD DataSize();				// f[^TCY擾
	BYTE *Buffer();					// f[^ւ̃|C^擾
	
	bool GetData( BYTE *, WORD );	// f[^擾
	bool SetData( BYTE *, WORD );	// f[^ݒ
	
	bool Resize( BYTE );			// f[^TCYύX
	
	FDSEC *Next();					// ̃ZN^ւ̃|C^擾
	void SetNext( FDSEC * );		// ̃ZN^ւ̃|C^ݒ
	int SectorOffset();				// ZN^ItZbg擾
	void SetSectorOffset( int );	// ZN^ItZbgݒ
	DWORD RelTime();				// CfbNXz[̎(us)擾
	void SetRelTime( DWORD );		// CfbNXz[̎(us)ݒ

};


// gbNNX
class FDTRK {
private:
	BYTE fdtype;					// fBXN̎(1D,2D,1DD,2DD,2HD)
	FDSEC *sectors;					// ZN^IuWFNgւ̃|C^
	
	void SetSectorOffset();			// ZN^ItZbgݒ
	
public:
	FDTRK();						// RXgN^
	~FDTRK();						// fXgN^
	
	void SetType( BYTE );			// fBXN̎ސݒ
	
	BYTE Count();					// ZN^擾
	FDSEC *Sector( BYTE=1 );		// ZN^擾
	FDSEC *AddSector( BYTE, BYTE, BYTE, BYTE, BYTE, BYTE=0, BYTE=0 );	// ZN^ǉ
	BYTE Gap3();					// GAP3擾
	int SpritSector( int, BYTE );	// ZN^߂(~bNXZN^tH[}bg)
	
	bool Format( BYTE, BYTE, BYTE, BYTE, BYTE );	// tH[}bg
	void Unformat();				// AtH[}bg
	
	BYTE ActualSectorSize( int );	// ۂɗLƎvZN^TCY擾(DATA CRC ERRORZN^̏ꍇ)
	bool CheckUniqueData( int );	// Pf[^ZN^?

};


// tbs[fBXNC[WNX
class FDimg {
protected:
	FDTRK track[MAX_CYLINDER*2];	// gbNe[u
	char title[256];				// fBXN̖O
	BYTE fdtype;					// fBXN̎(1D,2D,1DD,2DD,2HD)
	bool protect;					// CgveNg
	
	virtual bool ReadFileTrack( FILE *, BYTE, FDTRK * ) = 0;	// gbNf[^Ǎ
	virtual bool WriteFileTrack( FILE *, BYTE, FDTRK * ) = 0;	// gbNf[^
	
	bool IsSingleSide();			// ЖʃfBXN?
	
public:
	FDimg();						// RXgN^
	~FDimg();						// fXgN^
	
	FDTRK *Track( BYTE, BYTE );		// gbN擾
	char *Title();					// fBXN̖O擾
	void SetTitle( const char * );	// fBXN̖Oݒ
	BYTE Type();					// fBXN̎ގ擾
	void SetType( BYTE );			// fBXN̎ސݒ
	bool Protect();					// CgveNg擾
	void SetProtect( bool );		// CgveNgݒ
	
	void Unformat();				// AtH[}bg
	
	virtual bool ReadFromFile( const char * ) = 0;			// C[Wt@CǍ
	virtual bool WriteToFile( const char *, BYTE=0 ) = 0;	// C[Wt@Cɏ
};


// D88fBXNC[WNX
class D88DISK : public FDimg {
private:
	bool ReadFileTrack( FILE *, BYTE, FDTRK * );	// gbNf[^Ǎ
	bool WriteFileTrack( FILE *, BYTE, FDTRK * );	// gbNf[^
	
public:
	D88DISK();						// RXgN^
	~D88DISK();						// fXgN^
	
	bool ReadFromFile( const char * );			// C[Wt@CǍ
	bool WriteToFile( const char *, BYTE=0 );	// C[Wt@Cɏ
};


#endif
